%global meadalpha %{nil}
%global meadrel %{nil}
%global version_major 1
%global version_minor 1
%global version_micro 0
%global commitid 92b80fb3b6465d7d795cd8d886ded5fef008ff3b
%global serial 1
# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%{?scl:%scl_package %{?scl_prefix}apache-commons-daemon-jsvc}
%{!?scl:%global pkg_name %{name}}

%bcond_without native

%define base_name   daemon
%define short_name  commons-%{base_name}

%define reltag .redhat_2

# jsvc variables used for creating zips
%define zipnamejsvc jbcs-jsvc
%define jsvc_major 1
%define jsvc_minor 1

%define jsvc_version 1.1.0
%define jcdaemonVersion 1.1.0

Name:           %{?scl_prefix}apache-commons-daemon-jsvc
Version:        1.1.0
Release:        %{serial}%{?reltag}%{?dist}
Epoch:          1
Summary:        Defines API to support an alternative invocation mechanism
License:        ASL 2.0
Group:          Applications/System
URL:            http://commons.apache.org/daemon/
Source0:        commons-daemon-%{commitid}.tar.gz
Patch0:          %{pkg_name}-crosslink.patch
#based on http://pkgs.fedoraproject.org/cgit/apache-commons-daemon.git/tree/apache-commons-daemon-secondary.patch
#Not needed for EAP build
#Patch2:          %{pkg_name}-ia64-configure.patch
#Patch3:          %{pkg_name}-s390x-configure.patch
#Patch4:          %{pkg_name}-ppc64-configure.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
%if "%{?rhel}" == "7"
#64 bit only natives on RHEL 7
ExcludeArch:   i686 i386
%endif

%if %with native
%if "%{?rhel}" == "7"
BuildRequires:  java-devel
%else
BuildRequires:  java7-devel
%endif
BuildRequires:  libcap-devel
BuildRequires:  docbook-dtds
BuildRequires:  docbook-style-xsl
BuildRequires:  docbook-utils
BuildRequires:  xmlto
BuildRequires: 	autoconf
BuildRequires:  unzip
%endif
BuildRequires:  %{?scl_prefix}javapackages-tools
BuildRequires:  %{?scl_prefix}apache-commons-daemon

Requires:  %{?scl_prefix}apache-commons-daemon

Requires:       libcap
# Use whatever daemon is appropriate to the Server jsvc is used with
#Requires:       apache-commons-daemon-eap6

#win-buildrequires: xbuild

%description
The scope of this package is to define an API in line with the current
Java(tm) Platform APIs to support an alternative invocation mechanism
which could be used instead of the above mentioned public static void
main(String[]) method.  This specification cover the behavior and life
cycle of what we define as Java(tm) daemons, or, in other words, non
interactive Java(tm) applications.

%package zip
Summary:     Container for the zip distribution of %{pkg_name}
Group:       Development

%description zip
Container for the zip distribution of %{pkg_name}.

%package src-zip
Summary:     Container for the source zip distribution of %{pkg_name}
Group:       Development

%description src-zip
Container for the source zip distribution of %{pkg_name}.

%prep
%setup -q -n %{short_name}-%{commitid}
%patch0 -p0
#Not needed for EAP build
#%patch2 -p0
#%patch3 -p0 -b .s390x
#%patch4 -p0 -b .ppc
chmod 644 src/samples/*
%if %with native
# use the one from docbook instead of getting it from the net
catalogfile=`xmlcatalog /etc/xml/catalog "-//OASIS//DTD DocBook XML V4.1.2//EN"|sed -e s:"file\://"::`
sed -i -e s:"http\://www.oasis-open.org/docbook/xml/4.1.2/docbookx.dtd":$catalogfile: src/native/unix/man/jsvc.1.xml

pushd src/native/unix
%if 0
#work with docbook-xsl (from docbook-maven on rhel 6)
unzip -q %{_javadir}/docbook-xsl-resources.zip
export XSL_DIR=$XSL_DIR:`pwd`/docbook/html:`pwd`/docbook/manpages:`pwd`/docbook/common
xmlto -x docbook/manpages/docbook.xsl man man/jsvc.1.xml
%else
xmlto man man/jsvc.1.xml
%endif
popd
%endif
#sed -i -e '2425s/powerpc/powerpc*/' src/native/unix/configure

# Create src-zip
zip -q -r ../%{zipnamejsvc}-%{version}-src.zip *

%build
%if %with native
cd src/native/unix
autoconf
#%%configure --with-java=%{java_home}
%configure --with-java=/usr/lib/jvm/java
make %{?_smp_mflags}
%endif


%install
rm -rf $RPM_BUILD_ROOT

install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/jbossas-fordev

%if %with native
install -Dpm 0644 src/native/unix/jsvc.1 $RPM_BUILD_ROOT%{_root_mandir}/man1/jsvc.jbcs.1
# FIXME: Test the bindir location and drp the root_bindir if possible
# and in that case remove the symlink to commons-daemon.jar as well
install -Dpm 755 src/native/unix/jsvc $RPM_BUILD_ROOT%{_root_bindir}/jbcs-jsvc/jsvc
install -Dpm 755 src/native/unix/jsvc $RPM_BUILD_ROOT%{_bindir}/jsvc
pushd $RPM_BUILD_ROOT%{_root_bindir}/jbcs-jsvc
%{?scl:scl enable %{scl} - << \EOF}
ln -s `build-classpath commons-daemon` commons-daemon.jar
%{?scl:EOF}
popd

# Create zip
mkdir -p %{zipnamejsvc}-%{jsvc_major}.%{jsvc_minor}
pushd %{zipnamejsvc}-%{jsvc_major}.%{jsvc_minor}

#https://issues.jboss.org/browse/JCSP-28
mkdir -p sbin
# copy jsvc from /opt/rh/jbcs-httpd24/root/usr/bin/jsvc
cp -pr $RPM_BUILD_ROOT%{_bindir}/jsvc sbin/
mkdir -p lib
# copy c-d.jar from /opt/rh/jbcs-httpd24/root/usr/share/java/commons-daemon.jar
jarname=`ls -1 %{_javadir}/commons-daemon-%{jcdaemonVersion}.redhat*.jar | grep -v source`
cp  ${jarname} lib/commons-daemon.jar
mkdir -p doc
cp -pr %{_docdir}/%{?scl_prefix}apache-commons-daemon-%{jcdaemonVersion}/LICENSE.txt doc/
cp -pr %{_docdir}/%{?scl_prefix}apache-commons-daemon-%{jcdaemonVersion}/NOTICE.txt doc/
cp -pr %{_docdir}/%{?scl_prefix}apache-commons-daemon-%{jcdaemonVersion}/README doc/
cp -pr %{_docdir}/%{?scl_prefix}apache-commons-daemon-%{jcdaemonVersion}/RELEASE-NOTES.txt doc/
popd

# create jboss jsvc zip
find %{zipname}-%{jbcs_major}.%{jbcs_minor} -name "*.orig" | xargs rm -fr
zip -y -q -r ../jbcs-jsvc-%{jsvc_version}-RHEL%{?rhel}-%{_arch}.zip %{zipnamejsvc}-%{jsvc_major}.%{jsvc_minor}

rm -rf %{zipname}-%{jbcs_major}.%{jbcs_minor}

install -p -m 644 ../%{zipnamejsvc}-%{jsvc_version}-RHEL%{?rhel}-%{_arch}.zip \
        $RPM_BUILD_ROOT%{_javadir}/jbossas-fordev/
%endif

install -p -m 644 ../%{zipnamejsvc}-%{version}-src.zip \
        $RPM_BUILD_ROOT%{_javadir}/jbossas-fordev/

%clean
rm -rf $RPM_BUILD_ROOT

%if %with native
%files
%defattr(-,root,root,-)
%doc LICENSE*
%dir %{_root_bindir}/jbcs-jsvc
%{_root_bindir}/jbcs-jsvc/jsvc
%{_bindir}/jsvc
%{_root_bindir}/jbcs-jsvc/commons-daemon.jar
%{_root_mandir}/man1/jsvc.jbcs.1*

%files zip
%defattr(-,root,root,-)
%{_javadir}/jbossas-fordev/%{zipnamejsvc}-%{jsvc_version}-RHEL%{?rhel}-%{_arch}.zip
%endif

%files src-zip
%defattr(-,root,root,-)
%{_javadir}/jbossas-fordev/%{zipnamejsvc}-%{version}-src.zip

%changelog
* Thu Jun 14 2018 Georgios Zaronikas- Karagiannis <gzaronik@redhat.com> - 1.1.0-1
- JSVC 1.1

* Wed Jun 13 2018 Georgios Zaronikas- Karagiannis <gzaronik@redhat.com> - 1.1.0-18
- 1.1.0

* Thu May 31 2018 George Zaronikas <gzaronik@redhat.com> - 1.1.0-2
- Rebasing to 1.1.0

* Sun Mar 25 2018 Coty Sutherland <csutherl@redhat.com> - 1.0.15-18
- Rebuilding RPM wrapper to create zip sub-package

* Thu Mar 22 2018 Coty Sutherland <csutherl@redhat.com> - 1.0.15-18
- Rebuilding RPM wrapper to create zip sub-package

* Wed Mar 21 2018 Coty Sutherland <csutherl@redhat.com> 1.0.15-18
- Resolves: JBCS-485 jsvc zip is built inside jbcs-httpd24-compose

* Tue Mar 01 2016 Fernando Nasser <fnasser@redhat.com> - 1.0.15-17
- Add executable in correct SCL location

* Tue Feb 16 2016 Fernando Nasser <fnasser@redhat.com> - 1.0.15-16
- Activate source-repos feature

* Mon Feb 15 2016 David Walluck <dwalluck@redhat.com> 1:1.0.15-15
- fix symlink to commons-daemon.jar

* Mon Feb 15 2016 David Walluck <dwalluck@redhat.com> 1:1.0.15-14
- remove bcond redefinitions

* Thu Feb 11 2016 Fernando Nasser <fnasser@redhat.com> - 1.0.15-13
- Hardcode symlink target until jbcs-httpd24-javapackage-tools is available

* Thu Feb 11 2016 Fernando Nasser <fnasser@redhat.com> - 1.0.15-12
- Add symlink to commons-daemon.jar

* Mon Feb 08 2016 Fernando Nasser <fnasser@redhat.com> - 1.0.15-11
- Use serial macro in release
- Sync reltag with Java portion

* Tue Dec 22 2015 Fernando Nasser <fnasser@redhat.com> - 1:1.0.15-10
- Build in the jbcs-httpd24 collection

* Tue Oct 28 2014 Permaine Cheung <pcheung@redhat.com> - 1:1.0.15-9.redhat_2
- Rebuild

* Tue Oct 28 2014 Permaine Cheung <pcheung@redhat.com> - 1:1.0.15-8.redhat_2
- Rebuild

* Mon Oct 20 2014 Permaine Cheung <pcheung@redhat.com> - 1:1.0.15-7.redhat_2
- JWS 3.0 build

* Fri Jul 11 2014 Permaine Cheung <pcheung@redhat.com> - 1:1.0.15-6.redhat_2
- Rebuild

* Wed Apr 02 2014 Permaine Cheung <pcheung@redhat.com> - 1:1.0.15-5.redhat_2
- Rebuild

* Mon Mar 31 2014 Permaine Cheung <pcheung@redhat.com> - 1:1.0.15-4.redhat_2
- Rebuild

* Thu Mar 27 2014 Permaine Cheung <pcheung@redhat.com> - 1:1.0.15-3.redhat_2
- Specify BR :  java-devel >= 1.6.0, rebuild as ppc64 builders are enabled
- Add secondary patch (based on the fedora one) for ppc64 build

* Thu Jul 04 2013 Permaine Cheung <pcheung@redhat.com> - 1:1.0.15-2.redhat_2
- Fix R:libcap (BZ #971866)

* Thu Apr 11 2013 Permaine Cheung <pcheung@redhat.com> - 1:1.0.15-1.redhat_1
- 1.0.15

* Mon Mar 18 2013 Permaine Cheung <pcheung@redhat.com> - 1:1.0.14-1.redhat_1
- 1.0.14
- Remove the patch that has been incorporated in the new tag

* Thu Mar 07 2013 Permaine Cheung <pcheung@redhat.com> - 1:1.0.13-2.redhat_1
- Add R: apache-commons-daemon-eap6

* Wed Feb 13 2013 Permaine Cheung <pcheung@redhat.com> - 1:1.0.13-1.redhat_1
- 1.0.13

* Thu Jan 31 2013 Permaine Cheung <pcheung@redhat.com> - 1:1.0.12-1.redhat_1
- 1.0.12
- Merge ep-5-rhel-5 specific into this branch for ease of maintanence
- Add .redhat_1 to Release

* Thu Sep 06 2012 Permaine Cheung <pcheung@redhat.com> - 1:1.0.10-3
- Add missing man page
- Add zip subpackage

* Tue May 29 2012 Permaine Cheung <pcheung@redhat.com> - 1:1.0.10-2
- Keep name as jsvc

* Mon May 28 2012 Permaine Cheung <pcheung@redhat.com> - 1:1.0.10-1
- Rename to apache-commons-daemon-jsvc-eap6

* Tue Feb 28 2012 Permaine Cheung <pcheung@redhat.com> - 1:1.0.10-1
- Upgrade to 1.0.10

* Fri Nov 25 2011 Permaine Cheung <pcheung@redhat.com> - 1:1.0.8-1
- Upgrade to 1.0.8
- Remove patches that are already incorporated

* Mon Aug 15 2011 Permaine Cheung <pcheung@redhat.com> - 1:1.0.5-1.5.patch01
- Add fix for CVE-2011-2729

* Mon Mar 21 2011 Permaine Cheung <pcheung@redhat.com> - 1:1.0.5-1.4
- Fix BZ669259 (JBPAPP-6136)

* Wed Jan 26 2011 Permaine Cheung <pcheung@redhat.com> - 1:1.0.5-1.2
- Add patch for DAEMON-194

* Mon Jan 17 2011 Permaine Cheung <pcheung@redhat.com> - 1:1.0.5-1.1
- Upgrade to 1.0.5
- Split this from jakarta-commons-daemon into its own build
